﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HUDOneRR
{
    class CISTATUS
    {
        public enum CI_GPS_STATUS
        {
            SC_GPS_OFF = 0,
            SC_GPS_FIX_ACQUIRED,
            SC_GPS_SEARCHING,
            SC_GPS_FILTERING_ALERT
        }

        public enum CI_PILOT_MODE
        {
            PM_WORD = 0,	// FULL WORD, E.G. "HIGHWAY"
            PM_LETTER,      // SINGLE LETTER, E.G. "H"
            PM_DOT,		    // SCANNING DOT
            PM_VOLTAGE,     // VEHICLE VOLTAGE
            PM_SPEED,       // VEHICLE SPEED
            PM_COUNTDOWN	// COUNTDOWN TO MARKED LOCATION
        }

        public enum CI_SENSITIVITY
        {
            S_AUTO = 0x00,
            S_HIGHWAY = 0x05,
            S_AUTO_NO_X = 0x06,
            S_UNKNOWN = 0xFF        
        }

        public enum CI_STD_BAND
        {
            CB_X = 0x00,
            CB_K = 0x08,
            CB_KA = 0x10
        }

        public enum CI_STRING_TYPE
        {
            ST_NORMAL = 0x00,		// NORMAL TEXT
            ST_FLYING = 0x02,		// TEXT FLIES IN FROM THE RIGHT
            ST_INVISIBLE = 0x10		// CAUSES THE DISPLAY TO BE ERASED
        }

        public bool alert
        {
            get { lock(this) return m_alert; }
            set { lock(this) m_alert = value; }
        }

        public bool active
        {
            get { lock(this) return m_active; }
            set { lock(this) m_active = value; }
        }

        public CI_STD_BAND band
        {
            get { lock(this) return m_band; }
            set { lock(this) m_band = value; }
        }

        public byte rssi
        {
            get { lock(this) return m_rssi; }
            set { lock(this) m_rssi = value; }
        }

        public ulong exp
        {
            get { lock(this) return m_exp; }
            set { lock(this) m_exp = value; }
        }

        public ulong freq
        {
            get { lock(this) return m_freq; }
            set { lock(this) m_freq = value; }
        }

        public byte brg
        {
            get { lock(this) return m_brg; }
            set { lock(this) m_brg = value; }
        }

        public ulong dist
        {
            get { lock(this) return m_dist; }
            set { lock(this) m_dist = value; }
        }

        public byte volume
        {
            get { lock(this) return m_volume; }
            set { lock(this) m_volume = value; }
        }

        public byte brightness
        {
            get { lock(this) return m_brightness; }
            set { lock(this) m_brightness = value; }
        }

        public CI_GPS_STATUS gps_stat
        {
            get { lock(this) return m_gps_stat; }
            set { lock(this) m_gps_stat = value; }
        }

        public CI_PILOT_MODE pilot_mode
        {
            get { lock(this) return m_pilot_mode; }
            set { lock(this) m_pilot_mode = value; }
        }

        public CI_SENSITIVITY sensitivity
        {
            get { lock(this) return m_sensitivity; }
            set { lock(this) m_sensitivity = value; }
        }

        public byte voltage
        {
            get { lock(this) return m_voltage; }
            set { lock(this) m_voltage = value; }
        }

        public byte speed
        {
            get { lock(this) return m_speed; }
            set { lock(this) m_speed = value; }
        }

        public CI_STRING_TYPE strtype
        {
            get { lock(this) return m_strtype; }
            set { lock(this) m_strtype = value; }
        }

        public string str
        {
            get { lock(this) return m_str; }
            set { lock(this) m_str = value; }
        }

        bool m_alert = false;                                       // TRUE IF AN ALERT IS ACTIVE
        bool m_active = false;                                      // TRUE IF THE DISPLAY IS ACTIVE
        CI_STD_BAND m_band = CI_STD_BAND.CB_X;                      // BAND INFO FOR STD ALERT
        byte m_rssi = 0;                                            // SIGNAL STRENGTH FOR STD ALERT
        ulong m_exp = 0;		                                    // EXPERT METER ALERT DATA
        ulong m_freq = 0;                                           // SPEC MODE RADAR FREQUENCY
        byte m_brg = 0;                                             // BEARING TO MARKED LOCATION
        ulong m_dist = 0;		                                    // DISTANCE TO MARKED LOCATION
        byte m_volume = 0;		                                    // LAST KNOWN VOLUME SETTING
        byte m_brightness = 0;	                                    // LAST KNOWN BRIGHTNESS SETTING
        CI_GPS_STATUS m_gps_stat = CI_GPS_STATUS.SC_GPS_OFF;        // CURRENT GPS STATUS
        CI_PILOT_MODE m_pilot_mode = CI_PILOT_MODE.PM_WORD;	        // PILOT MODE
        CI_SENSITIVITY m_sensitivity = CI_SENSITIVITY.S_UNKNOWN;    // SENSITIVITY BITS
        byte m_voltage = 0;		                                    // VEHICLE VOLTAGE
        byte m_speed = 0;		                                    // VEHICLE SPEED
        CI_STRING_TYPE m_strtype = CI_STRING_TYPE.ST_NORMAL;	    // STRING TYPE CODE
        string m_str = "";	                                        // MOST RECENTLY DISPLAYED STRING
    }
}
