﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HUDOneRR
{
    class V1STATUS
    {
        // MODE DEFINITIONS
        public const byte MODE_UNKNOWN = 0;
        public const byte MODE_ALL_BOGEYS = 1;
        public const byte MODE_LOGIC = 2;
        public const byte MODE_ADVANCED_LOGIC = 3;

        // BAND FLAG DEFINITIONS
        public const byte BF_XBAND = 0x01;
        public const byte BF_KBAND = 0x02;
        public const byte BF_KABAND = 0x04;
        public const byte BF_KUBAND = 0x08;
        public const byte BF_LASER = 0x10;

        // ARROW FLAG DEFINITIONS
        public const byte AF_REAR = 0x01;
        public const byte AF_SIDES = 0x02;
        public const byte AF_FRONT = 0x04;

        public bool alert
        {
            get { lock(this) return m_alert; }
            set { lock(this) m_alert = value; }
        }

        public bool active
        {
            get { lock(this) return m_active; }
            set { lock(this) m_active = value; }
        }

        public bool mute
        {
            get { lock(this) return m_mute; }
            set { lock(this) m_mute = value; }
        }

        public bool junk
        {
            get { lock(this) return m_junk; }
            set { lock(this) m_junk = value; }
        }

        public byte mode
        {
            get { lock(this) return m_mode; }
            set { lock(this) m_mode = value; }
        }

        public byte bands
        {
            get { lock(this) return m_bands; }
            set { lock(this) m_bands = value; }
        }

        public byte priority_bands
        {
            get { lock(this) return m_priority_bands; }
            set { lock(this) m_priority_bands = value; }
        }

        public byte arrows
        {
            get { lock(this) return m_arrows; }
            set { lock(this) m_arrows = value; }
        }

        public byte priority_arrows
        {
            get { lock(this) return m_priority_arrows; }
            set { lock(this) m_priority_arrows = value; }
        }

        public byte bogey_count
        {
            get { lock(this) return m_bogey_count; }
            set { lock(this) m_bogey_count = value; }
        }

        public byte rssi
        {
            get { lock(this) return m_rssi; }
            set { lock(this) m_rssi = value; }
        }

        bool m_alert = false;       // TRUE IF AN ALERT IS ACTIVE
        bool m_active = false;      // TRUE IF A NON-ALERT DISPLAY IS ACTIVE
        bool m_mute = false;        // TRUE IF V1 MUTE BIT IS SET
        bool m_junk = false;        // TRUE IF ALERT WAS JUNKED-OUT
        byte m_mode = MODE_UNKNOWN; // V1MODE
        byte m_bands = 0;           // BF_XXX
        byte m_priority_bands = 0;  // BF_XXX
        byte m_arrows = 0;          // AF_XXX
        byte m_priority_arrows = 0; // AF_XXX
        byte m_bogey_count = 0;	    // BOGEY COUNTER [0..10]
        byte m_rssi = 0;            // SIGNAL STRENGTH [0..8]
    }
}
